#
#Version 5.2
#This version has a 2 min entrance and exit dalay
#This version of the software works with the RFID reader,
#and the key switch
#This software is for use with Rev 4.5 of the PCB
#
#sudo apt-get install alsaaud*
#sudo pip3 install rpi_lcd
#sudo apt-get install -y espeak

import RPi.GPIO as GPIO
import time
import os
import threading
from rpi_lcd import LCD

lcd=LCD()

#Broadcom numbering scheme
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False) 

# Pin assignments

zone1 = 16 	#J15-36
zone2 = 17 	#J15-11
zone3 = 18 	#J15-12
zone4 = 19 	#J15-35
zone5 = 20	#J15-38
zone6 = 21	#J15-40
zone7 = 22	#J15-15
zone8 = 23	#J15-16
tamper = 25	#J15-22
arm = 24 	#J15-18
disarm = 26 #J15-37
alarm = 27 	#J15-13
fire1 = 5	#J15-29
fire2 = 6	#J15-31

# TTS Speech Strings

zone1_txt = "Entry detected in Zone 1"
zone2_txt = "Alarm detected in Zone 2"
zone3_txt = "Alarm detected in Zone 3"
zone4_txt = "Alarm detected in Zone 4"
zone5_txt = "Alarm detected in Zone 5"
zone6_txt = "Alarm detected in Zone 6"
zone7_txt = "Alarm detected in Zone 7"
zone8_txt = "Alarm detected in Zone 8"
arm_txt = "System Armed"
disarm_txt = "System Disarmed"
tamper_txt ="Tamper switch activated"
fire_txt = "Fire Detected"

#Pin Setup

GPIO.setup(alarm,GPIO.OUT) #Set Alarm pin as an output

#Setup Zone pins as inputs with internal pull up
GPIO.setup(zone1, GPIO.IN, pull_up_down=GPIO.PUD_UP) 
GPIO.setup(zone2, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(zone3, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(zone4, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(zone5, GPIO.IN, pull_up_down=GPIO.PUD_UP) 
GPIO.setup(zone6, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(zone7, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(zone8, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(arm, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(disarm, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(tamper, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(fire1, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(fire2, GPIO.IN, pull_up_down=GPIO.PUD_UP)


GPIO.output(alarm,GPIO.LOW)

lcd.clear 
lcd.text("   System Idle",1)
arm_flg = False
Card_flg = False

def CardRead():

   global Card_flg
   global card_id

   card_id = input()    
   Card_flg= True
   threading.Timer(1, CardRead).start()
   
def Entry():
	
	global arm_flg
	
#Check Disarm Switch

	if GPIO.input(disarm):
		 time.sleep(.1)
	else:
		 lcd.clear()
		 lcd.text("System Disarmed",1)
		 arm_flg=0
		 GPIO.output(alarm,GPIO.LOW) #Turn off siren
		 
#Check Zone 1

	if GPIO.input(zone1):
		 pass
	else:
		 
		 lcd.text("Entry Detected",1)
		 lcd.text("You have 2 min",2)
		 os.popen('espeak -ven+f5 "' + zone1_txt + '" --stdout | aplay 2> /dev/null').read()
		 time.sleep(120)
		 lcd.text("Your 2 min is up",2)
		 
	threading.Timer(1, Entry).start()	 	   


def fire():
	
	
#Check Fire Zone 1

	if GPIO.input(fire1):
		pass

	else:
		 lcd.text("      FIRE !",1)
		 lcd.text("Fire Zone 1",2)
		 os.popen('espeak -ven+f5 "' + fire_txt + '" --stdout | aplay 2> /dev/null').read()
		 arm_flg = True
		 GPIO.output(alarm,GPIO.HIGH) #Turn on Siren relay		 	 		 

#Check Fire Zone 2

	if GPIO.input(fire2):
		pass

	else:
		 lcd.text("      FIRE !",1)
		 lcd.text("Fire Zone 2",2)
		 os.popen('espeak -ven+f5 "' + fire_txt + '" --stdout | aplay 2> /dev/null').read()
		 arm_flg = True
		 GPIO.output(alarm,GPIO.HIGH) #Turn on Siren relay
		  
	threading.Timer(2, fire).start()	 
		 		 	 				 
CardRead()	#Comment out this line to use arm switch ONLY

fire()		#Check for fires

Entry()		#Check Zone 1 and Disarm Key

while arm_flg == False:
	
		#If we are not armed, check Arm switch

		if GPIO.input(arm):
			pass
		else:
			lcd.clear()
			lcd.text("  System Armed",1)
			lcd.text("  In 2 Minutes",2)
			time.sleep(120)
			lcd.text(" ",2)
			os.popen('espeak -ven+f5 "' + arm_txt + '" --stdout | aplay 2> /dev/null').read()
			arm_flg=True

		#See if a supervisor card has been swiped	
		
		if Card_flg == True:

			id_file = open("super.txt","r")

			for line in id_file:
				

				if (card_id == line.strip()):
					lcd.clear()
					lcd.text("  System Armed",1)
					lcd.text("  In 2 Minutes",2)
					time.sleep(120)
					lcd.text(" ",2)
					os.popen('espeak -ven+f5 "' + arm_txt + '" --stdout | aplay 2> /dev/null').read()
					arm_flg = True
					Card_flg = False
			else:
				pass


while True:
	
	#If we are not armed, check Arm switch
	if GPIO.input(arm):
			time.sleep(.1)
	else:
			lcd.clear()
			lcd.text("  System Armed",1)
			lcd.text("  In 2 Minutes",2)
			time.sleep(120)
			lcd.text(" ",2)
			os.popen('espeak -ven+f5 "' + arm_txt + '" --stdout | aplay 2> /dev/null').read()
			arm_flg=True


	if Card_flg == 1:

			id_file = open("super.txt","r")

			for line in id_file:

				if (card_id == line.strip()):
					lcd.clear()
					lcd.text("  System Armed",1)
					lcd.text("  In 2 Minutes",2)
					time.sleep(120)
					lcd.text(" ",2)
					os.popen('espeak -ven+f5 "' + arm_txt + '" --stdout | aplay 2> /dev/null').read()
					arm_flg = True
					Card_flg = False
			else:
				pass


#If we are armed, check zones
						
	while arm_flg == True: 

#Check Zone 2	 

	 if GPIO.input(zone2):
		 pass
	 else:
		 
		 lcd.text("      ALARM",1)
		 lcd.text("Zone 2",2)
		 os.popen('espeak -ven+f5 "' + zone2_txt + '" --stdout | aplay 2> /dev/null').read()		 
		 GPIO.output(alarm,GPIO.HIGH) #Turn on Siren relay

#Check Zone 3	 

	 if GPIO.input(zone3):
		 pass
	 else:
		 
		 lcd.text("      ALARM",1)
		 lcd.text("Zone 3",2)
		 os.popen('espeak -ven+f5 "' + zone3_txt + '" --stdout | aplay 2> /dev/null').read()		 
		 GPIO.output(alarm,GPIO.HIGH) #Turn on Siren relay
		 
#Check Zone 4	 

	 if GPIO.input(zone4):
		 pass
	 else:
		 
		 lcd.text("      ALARM",1)
		 lcd.text("Zone 4",2)
		 os.popen('espeak -ven+f5 "' + zone4_txt + '" --stdout | aplay 2> /dev/null').read()
		 GPIO.output(alarm,GPIO.HIGH) #Turn on Siren relay

#Check Zone 5	 

	 if GPIO.input(zone5):
		 pass
	 else:
		 
		 lcd.text("      ALARM",1)
		 lcd.text("Zone 5",2)
		 os.popen('espeak -ven+f5 "' + zone5_txt + '" --stdout | aplay 2> /dev/null').read()
		 GPIO.output(alarm,GPIO.HIGH) #Turn on Siren relay		 
		 
#Check Zone 6	 

	 if GPIO.input(zone6):
		 pass
	 else:
		 lcd.text("      ALARM",1)
		 lcd.text("Zone 6",2)
		 os.popen('espeak -ven+f5 "' + zone6_txt + '" --stdout | aplay 2> /dev/null').read()
		 GPIO.output(alarm,GPIO.HIGH) #Turn on Siren relay
		 
#Check Zone 7	 

	 if GPIO.input(zone7):
		 pass
	 else:
		 
		 lcd.text("      ALARM",1)
		 lcd.text("Zone 7",2)
		 os.popen('espeak -ven+f5 "' + zone7_txt + '" --stdout | aplay 2> /dev/null').read()
		 GPIO.output(alarm,GPIO.HIGH) #Turn on Siren relay	
		 
#Check Zone 8	 

	 if GPIO.input(zone8):
		 pass
	 else:
		 
		 lcd.text("      ALARM",1)
		 lcd.text("Zone 8",2)
		 os.popen('espeak -ven+f5 "' + zone8_txt + '" --stdout | aplay 2> /dev/null').read()
		 GPIO.output(alarm,GPIO.HIGH) #Turn on Siren relay		 	 		 
		 
#Check Tamper Switch	 

	 if GPIO.input(tamper):

		 lcd.text("      ALARM",1)
		 lcd.text("Tamper Switch",2)
		 os.popen('espeak -ven+f5 "' + tamper_txt + '" --stdout | aplay 2> /dev/null').read()
		 GPIO.output(alarm,GPIO.HIGH) #Turn on Siren relay

#Check Disarm Switch

	 if GPIO.input(disarm):
		 time.sleep(.1)
	 else:
		 lcd.clear()
		 lcd.text("System Disarmed",1)
		 arm_flg=0
		 GPIO.output(alarm,GPIO.LOW) #Turn off siren
		 os.popen('espeak -ven+f5 "' + disarm_txt + '" --stdout | aplay 2> /dev/null').read()

#Check Arm Switch
	 
	 if GPIO.input(arm):
		 time.sleep(.1)
	 else:
		 lcd.clear()
		 lcd.text("  System Armed",1)
		 lcd.text("In 2 Minutes",2)
		 time.sleep(120)
		 lcd.text(" ",2)
		 os.popen('espeak -ven+f5 "' + arm_txt + '" --stdout | aplay 2> /dev/null').read()
		 arm_flg= True
	
#Check Card Reader

	 if Card_flg == True:
		 id_file = open("cards.txt","r")

		 for line in id_file:
			 
			 if (card_id == line.strip()):
				 
				 lcd.clear()
				 lcd.text("System Disarmed",1)
				 os.popen('espeak -ven+f5 "' + disarm_txt + '" --stdout | aplay 2> /dev/null').read()
				 GPIO.output(alarm,GPIO.LOW) #Turn off siren
				 arm_flg = False
				 Card_flg = False
		 else:
		     pass			 

	
